
const {success,error} = require("./functions");
const { check, validationResult } = require("express-validator");


const bodyParser = require('body-parser');
const config = require('./config');
const fetch = require("node-fetch");
const bcrypt = require('bcrypt');
const jwt = require("jsonwebtoken");




const express = require('express');
const app = express();

app.use(express.json());
app.use(bodyParser.urlencoded({ extended: false}));



const users = require('./data').userDB;
const cart = require('./data').cart;

const { Client } = require('pg')
const client = new Client({
  user: 'postgres',
  host: 'localhost',
  database: 'testdb',
  password: 'postgres',
  port: 5432,
})


client.connect(function(err) {
  if (err) throw err;
  console.log("Connected!");
});


function Pokemons(){

    return fetch("https://pokeapi.co/api/v2/pokemon/?limit=900")
    .then(response => response.json())
    .catch(error => console.error(error));
  
}

//effectue une requête
function get(that) {

    return fetch(that)
    .then(response => response.json())
    .catch(error => console.error(error));

}

let api = Pokemons();

api.then(pok =>{
    for(let i = 0; i<809; i++){

        let type1 = "none";
        let type2 = "none";
        try{

        
            get(pok.results[i].url).then(stat => {
                if(stat.types.length > 1){
                    type1 = stat.types[0].type.name;
                    type2 = stat.types[1].type.name;
                }
                else{
                    type1 = stat.types[0].type.name;
                }

                

                const text = 'INSERT INTO pokeshop.Pokemon(id,name,type1,type2) VALUES($1,$2,$3,$4) RETURNING *'
                const values = [i+1,pok.results[i].name, type1,type2]
                client.query(text, values, (err, res) => {
                    if (err) {
                      //console.log(err.stack)
                    } else {
                      //console.log(res.rows)
                    }
                })
                
            })
        }catch{
            console.log("Api error !");
        }   
    }
})

app.listen(config.port, ()=> console.log('Attrapez les tous !'))
