CREATE SCHEMA IF NOT EXISTS pokeshop;

--USE pokeshop;

CREATE TABLE IF NOT EXISTS pokeshop.User (
	id SERIAL PRIMARY KEY,
	username VARCHAR(32) NOT NULL,
	hash VARCHAR(128) NOT NULL DEFAULT ''
);

CREATE TABLE IF NOT EXISTS pokeshop.Panier (
	id SERIAL PRIMARY KEY,
	nb_articles INT  NOT NULL,
	prix INT  NOT NULL
);

CREATE TABLE IF NOT EXISTS pokeshop.Possede (
	panier_id INT NOT NULL,
    user_id INT NOT NULL,
    PRIMARY KEY (panier_id,user_id),
    CONSTRAINT fk_pokemon_id
		FOREIGN KEY (panier_id)
		REFERENCES pokeshop.Panier (id),
        CONSTRAINT fk_user_id
		FOREIGN KEY (user_id)
		REFERENCES pokeshop.User (id)
);

CREATE TABLE IF NOT EXISTS pokeshop.Pokemon (
	id SERIAL PRIMARY KEY,
	name VARCHAR(32) NOT NULL,
    type1 VARCHAR(100) NOT NULL,
    type2 VARCHAR(100) NOT NULL
    
);

CREATE TABLE IF NOT EXISTS pokeshop.Contient (
	pokemon_id INT NOT NULL,
    panier_id INT NOT NULL,
    PRIMARY KEY (pokemon_id,panier_id),
	CONSTRAINT fk_pokemon_id
		FOREIGN KEY (pokemon_id)
		REFERENCES pokeshop.Pokemon (id),
	CONSTRAINT fk_panier_id
		FOREIGN KEY (panier_id)
		REFERENCES pokeshop.Panier (id)

);

CREATE TABLE IF NOT EXISTS pokeshop.Attaque (
	id SERIAL PRIMARY KEY,
	name VARCHAR(32) NOT NULL,
	description VARCHAR(128) NOT NULL,
	type VARCHAR(32) NOT NULL,
	categorie VARCHAR(32) NOT NULL

);


CREATE TABLE IF NOT EXISTS pokeshop.Peut_apprendre (
	attaque_id INT NOT NULL,
    pokemon_id INT NOT NULL,
    PRIMARY KEY (pokemon_id,attaque_id),
	CONSTRAINT fk_pokemon_id
		FOREIGN KEY (pokemon_id)
		REFERENCES pokeshop.Pokemon (id),
	CONSTRAINT fk_panier_id
		FOREIGN KEY (attaque_id)
		REFERENCES pokeshop.Attaque (id)

);


CREATE TABLE IF NOT EXISTS pokeshop.Appris (
	attaque_id INT NOT NULL,
    pokemon_id INT NOT NULL,
    PRIMARY KEY (pokemon_id,attaque_id),
	CONSTRAINT fk_pokemon_id
		FOREIGN KEY (pokemon_id)
		REFERENCES pokeshop.Pokemon (id),
	CONSTRAINT fk_panier_id
		FOREIGN KEY (attaque_id)
		REFERENCES pokeshop.Attaque (id)
);


