
const {success,error} = require("./functions");
const { check, validationResult } = require("express-validator");


const bodyParser = require('body-parser');
const config = require('./config');
const fetch = require("node-fetch");
const bcrypt = require('bcrypt');
const jwt = require("jsonwebtoken");


const express = require('express');
const app = express();



const users = require('./data').userDB;
const cart = require('./data').cart;

const { Client } = require('pg')
const client = new Client({
  user: 'postgres',
  host: 'localhost',
  database: 'testdb',
  password: 'postgres',
  port: 5432,
})


client.connect(function(err) {
  if (err) throw err;
  console.log("Connected!");
});

app.use(express.json());
app.use(bodyParser.urlencoded({ extended: false}));
app.use(express.static('../frontend'));




app.get(config.rootApi + "pokemons/:id",function (req,res){
    
    let index = -1
    client.query('SELECT * FROM pokeshop.Pokemon', (err, result) => {
        
        for(let i = 0; i<809; i++){
            if(result.rows[i].id == req.params.id){
                index = i
            }
        }

        if(index!=-1){
            res.json(result.rows[index])
        }else{
            res.json({status: "error"})
        }
        
    })
    
    
})

app.get(config.rootApi + "pokemons",function (req,res){
    client.query('SELECT * FROM pokeshop.Pokemon', (err, result) => {
        if (err) {
            console.log(err.stack)
        } else {
            res.json(result.rows)
        }
    })

})




app.post('/register', async (req, res) => {
    console.log(req.body);
    
    try{
        let foundUser = users.find((data) => req.body.e === data.email);
        if (!foundUser) {

            let hashPassword = await bcrypt.hash(req.body.p, 10);

            let newUser = {
                username: req.body.u,
                email: req.body.e,
                password: hashPassword,
                cart:[]
            };
            users.push(newUser);
            console.log('User list', users);

            res.json({ msg: "success" });
        } else {
            res.json({ msg: "invalid" });
        }
    } catch{
        res.json({ msg: "error" });
    }
});

app.post('/login', async (req, res) => {
    
    try{

        let foundUser = users.find((data) => req.body.email.toLowerCase() === data.email.toLowerCase());
        if(!foundUser){
            foundUser = users.find((data) => req.body.email.toLowerCase() === data.username.toLowerCase());
        }

        if (foundUser) {

            let submittedPass = req.body.password;
            let storedPass = foundUser.password;

            const passwordMatch = await bcrypt.compare(submittedPass, storedPass);
            if (passwordMatch) {
                let usrname = foundUser.username;

                const token = jwt.sign({ id: foundUser.usrname }, "bush", {
                    expiresIn: "15m",
                })
                res.json({msg: "login success", token,usrname})
            } else {
                res.json({ msg: "invalid" });     
            }
        }
        else {
            res.json({ msg: "invalid" });
        }
    } catch{
        res.json({ msg: "error" });
    }
});

app.post('/me', async (req, res) => {

    let token = req.body.token;
    try{
        let check = jwt.verify(token,"bush");
        res.json({msg: "Connected", status: 1});
        
    }catch{
        if(!token){
            res.json({msg: "Disconnected", status: 0});
        }else{
            res.json({msg: "Session expired", status: -1});
        }
    }



})

app.post("/yourcart", async function(req,res){

    try{
        let foundUser = users.find((data) => req.body.username ===data.username);
        res.json(foundUser.cart);
    }catch{
        res.json({msg:"error occured"});
    }

})


app.put('/add', async (req, res) => {

    try{
        let foundUser = users.find((data) => req.body.username === data.username);
        foundUser.cart.push(req.body);

        res.end();
    }catch{
        res.json({msg: "error occured"});
    }
})


app.delete('/remove', async (req, res) => {

    try{
        let foundUser = users.find((data) => req.body.username === data.username);
        for(let i = 0; i<foundUser.cart.length; i++){
            if(foundUser.cart[i].pokemon.toLowerCase() === req.body.name.toLowerCase()){
                foundUser.cart.splice(i,1);
            }
        }

        res.end();
    }catch{
        res.json({msg: "error occured"});
    }
})

app.listen(config.port, ()=> console.log('Attrapez les tous !'))


function getIndex(id,tab){

    return (tab.map((a) => a.id).indexOf(parseInt(id)));
}
